#ifndef _Xrmcommandline_h
#define _Xrmcommandline_h

#include <X11/Xresource.h>

static XrmOptionDescRec options[] = {
//  For these options, try to use '+' to turn them on, and '-' to turn them
//    off, even though this is different from the usual tradition of -foo
//    turning on 'foo', which is off by default.  At least this way,
//    it is self-consistent, and self-explanatory.

//  General, X11 resources:
{ (char*)"-display", "*display", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-font", "*font", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-title", "*title", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-geometry", "*geometry", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-hmargin", "*horizontalMargin", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-vmargin", "*verticalMargin", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-vspacing", "*verticalSpacing", XrmoptionSepArg, (caddr_t) NULL },


//  XOSView-specific resources:
{ (char*)"-labels", "*labels", XrmoptionNoArg, "False" },
{ (char*)"+labels", "*labels", XrmoptionNoArg, "True" },
{ (char*)"-captions", "*captions", XrmoptionNoArg, "False" },
{ (char*)"+captions", "*captions", XrmoptionNoArg, "True" },
{ (char*)"-usedlabels", "*usedlabels", XrmoptionNoArg, "False" },
{ (char*)"+usedlabels", "*usedlabels", XrmoptionNoArg, "True" },
{ (char*)"-samplesPerSec", "*samplesPerSec", XrmoptionSepArg, (caddr_t) NULL },
//  CPU resources
{ (char*)"-cpu", "*cpu", XrmoptionNoArg, "False" },
{ (char*)"+cpu", "*cpu", XrmoptionNoArg, "True" },
{ (char*)"-cpus", "*cpuFormat", XrmoptionNoArg, "single" },
{ (char*)"+cpus", "*cpuFormat", XrmoptionNoArg, "all" },
// Load resources
{ (char*)"-load", "*load", XrmoptionNoArg, "False" },
{ (char*)"+load", "*load", XrmoptionNoArg, "True" },
// Memmeter resources
{ (char*)"-mem", "*mem", XrmoptionNoArg, "False" },
{ (char*)"+mem", "*mem", XrmoptionNoArg, "True" },
// Swapmeter resources
{ (char*)"-swap", "*swap", XrmoptionNoArg, "False" },
{ (char*)"+swap", "*swap", XrmoptionNoArg, "True" },
// Batterymeter resources
{ (char*)"-battery", "*battery", XrmoptionNoArg, "False" },
{ (char*)"+battery", "*battery", XrmoptionNoArg, "True" },
// Wirelessmeter resources
{ (char*)"-wireless", "*wireless", XrmoptionNoArg, "False" },
{ (char*)"+wireless", "*wireless", XrmoptionNoArg, "True" },
//  GFX resources
{ (char*)"-gfx", "*gfx", XrmoptionNoArg, "False" },
{ (char*)"+gfx", "*gfx", XrmoptionNoArg, "True" },

// Networkmeter resources
{ (char*)"-net", "*net", XrmoptionNoArg, "False" },
{ (char*)"+net", "*net", XrmoptionNoArg, "True" },
//  Previously, network was overloaded to be the bandwidth and the
//  on/off flag.  Now, we have -net for on/off, and networkBandwidth
//  for bandwidth, with the alias networkBW, and network for backwards
//  compatibility.
{ (char*)"-network", "*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-networkBW", "*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-networkBandwidth", "*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },

// Page Meter
{ (char*)"-page", "*page", XrmoptionNoArg, "False" },
{ (char*)"+page", "*page", XrmoptionNoArg, "True" },
{ (char*)"-pagespeed", "*pageBandWidth", XrmoptionSepArg, (caddr_t) NULL },

#if !defined(__hpux__) && !defined(__hpux)
//  Disk Meter Options
{ (char*)"-disk", "*disk", XrmoptionNoArg, "False" },
{ (char*)"+disk", "*disk", XrmoptionNoArg, "True" },
#endif

// Interrupt meter resources  --  all sorts of aliases.
{ (char*)"-int", "*interrupts", XrmoptionNoArg, "False" },
{ (char*)"+int", "*interrupts", XrmoptionNoArg, "True" },
{ (char*)"-ints", "*interrupts", XrmoptionNoArg, "False" },
{ (char*)"+ints", "*interrupts", XrmoptionNoArg, "True" },
{ (char*)"-interrupts", "*interrupts", XrmoptionNoArg, "False" },
{ (char*)"+interrupts", "*interrupts", XrmoptionNoArg, "True" },

// Intrate meter resources, for platforms that support it.
{ (char*)"-irqrate", "*irqrate", XrmoptionNoArg, "False" },
{ (char*)"+irqrate", "*irqrate", XrmoptionNoArg, "True" },
{ (char*)"-intrate", "*irqrate", XrmoptionNoArg, "False" },
{ (char*)"+intrate", "*irqrate", XrmoptionNoArg, "True" },

// lmstemp resources
{ (char*)"-lmstemp", "*lmstemp", XrmoptionNoArg, "False" },
{ (char*)"+lmstemp", "*lmstemp", XrmoptionNoArg, "True" },
// coretemp resources
{ (char*)"-coretemp", "*coretemp", XrmoptionNoArg, "False" },
{ (char*)"+coretemp", "*coretemp", XrmoptionNoArg, "True" },
// acpitemp resources
{ (char*)"-acpitemp", "*acpitemp", XrmoptionNoArg, "False" },
{ (char*)"+acpitemp", "*acpitemp", XrmoptionNoArg, "True" },

//  Special, catch-all option here --
//    xosview -xrm "*memFreeColor: purple" should work, for example.
{ (char*)"-xrm", "*xrm", XrmoptionResArg, (caddr_t) NULL },
};
//  This auto-detects changes in the number of options.
static const int NUM_OPTIONS = sizeof(options) / sizeof(options[0]);

#endif
